<template>

    <div class="container flex flex-col h-full pt-6 mx-auto" v-if="interruptionMode">

        <div class="flex justify-center mb-8">
            <div class="pulse w-24 h-24 bg-red-600 flex items-center justify-around rounded-full">
                <fa icon="pause" class="inline-block text-white" style="font-size: 60px;" />
            </div>
        </div>

        <p class="text-xl text-center font-bold uppercase mb-1">Unterbrechung</p>
        <p class="text-center mb-6">{{ activeDurationFormatted }}</p>

        <div class="h-full shadow-md border bg-white flex flex-col">
            <div class="md:flex max-h-full">
                <div class="md:w-1/2 p-5">
                    <tw-textarea v-model="interruptionMessage" label="Beschreibung" class="mb-3" />
                    <tw-textarea v-model="interruptionComment" label="Kommentar" />
                </div>
                <div class="md:w-1/2 flex flex-col p-3 px-4 md:p-5">
                    <customers :select-cost-unit="stopInterruption" />
                </div>
            </div>
        </div>
    </div>


    <div class="sm:flex sm:flex-wrap md:flex-no-wrap md:h-full pt-6" v-else>
        <!-- TIMELINE -->
        <div class="sm:w-1/2 md:w-1/3 max-h-full flex flex-col sm:pr-1 md:pr-0">
            <div class="flex items-center mb-2 px-2" style="min-height: 40px">
                <div class="flex-grow">
                    <custom-button v-if="$store.state.timeline.active" icon="pause" @click="interruption" negative></custom-button>
                </div>
                <span class="ml-2 px-2">
                    <fa icon="clock" class="rounded-full relative z-10 mr-2" :class="{'pulse pulse--small': $store.state.timeline.active}" />
                    <span class="relative z-20">{{ $time.formatDuration(totalDuration) }}</span>
                </span>
            </div>

            <time-item class="mx-2 md:mr-6 z-30 bg-gray-300 shadow-lg" v-if="activeItem" v-bind:item="activeItem" :restart="restartTime" :stop="stopTimer" :timeline="timeline" :async="sendSocketSyncRequest" />

            <div class="flex-grow overflow-y-auto p-2">
              <div v-for="(item, index) in timelineListWithoutActive" v-bind:key="item.id" :class="(index !== 0 ? 'mt-3' : 'mt-3')">
                  <time-item v-bind:item="item" :async="sendSocketSyncRequest" :restart="restartTime" :stop="stopTimer" :timeline="timeline" />
              </div>
            </div>

            <div class="mt-2 px-2 pt-2 flex">
                <custom-button icon="arrow-left" @click="prevDay"></custom-button>
                <el-date-picker
                    class="mx-1 flex-grow"
                    v-model="date"
                    type="date"
                    placeholder="Pick a day"
                    :picker-options="pickerOptions"
                >
                </el-date-picker>
                <custom-button icon="arrow-right" @click="nextDay"></custom-button>
            </div>
        </div>

        <!-- ISSUES -->
        <div class="mt-6 sm:mt-0 sm:w-1/2 md:w-1/3 max-h-full flex flex-col sm:pl-1 md:pl-0 md:mx-2">
            <div class="text-gray-600 clearfix mb-2 flex align-middle px-2">
              <input class="flex-grow border border-gray-400 bg-white h-10 px-3 rounded text-sm focus:outline-none" autocomplete="off" v-model="issueQuery" type="search" name="search" placeholder="Search">
              <custom-button css-class="ml-2" icon="sync" @click="issues()"></custom-button>
            </div>

            <div class="flex-grow overflow-y-auto p-2">
                <div class="text-gray-600 text-center text-sm" v-if="issuesList.length == 0">
                  No issues found with required label.
                </div>
                <div
                  v-for="item in issuesList"
                  :key="item.id"
                  @click="startIssueTimer(item)"
                  :class="{'bg-gray-200': $store.state.timeline.active && $store.state.timeline.active.issue_id == item.id}"
                  class="shadow bg-white pt-2 pb-2 px-2 hover:bg-gray-200 hover:shadow-md rounded mb-3 cursor-pointer"
                >
                    <div class="flex items-start">
                        <span class="inline-block text-xs bg-pink-300 px-2 py-1 rounded mb-2" v-if="item.milestone">{{ item.milestone }}</span>
                        <fa icon="clock" class="rounded-full ml-auto pulse pulse--small" v-if="$store.state.timeline.active && $store.state.timeline.active.issue_id == item.id" />
                    </div>
                    <div class="text-left">
                        <p class="text-xs text-gray-700 leading-tight mb-1">{{ item.project }}</p>
                        <h3 class="mb-2" v-html="item.title"></h3>
                        <div class="flex items-center">
                            <div class="flex-grow">
                                <span
                                    v-for="label in item.labels"
                                    :key="label.label"
                                    :style="{'background-color': label.color, 'color': label.text_color}"
                                    class="rounded-full inline-block text-xs py-1 px-2 mr-1 bg-red-600 text-white"
                                >
                                    {{ label.name }}
                                </span>
                            </div>
                            <custom-button css-class="ml-2 px-2 py-1" :icon="['fab', 'gitlab']" @click="openGitlabLink(item)"></custom-button>
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <!-- COST UNITS -->
        <div class="sm:w-full sm:mt-6 md:w-auto md:mt-0 md:w-1/3 max-h-full flex flex-col">
            <customers :select-cost-unit="startCostUnitTimer" />
        </div>
    </div>

</template>

<script>
import Vue from 'vue'
import CustomButton from '~/components/CustomButton'
import TimeItem from '~/components/TimeItem.vue'
import Customers from '~/components/Customers.vue'
import TwTextarea from '~/components/TwTextarea'
import VueNativeSock from 'vue-native-websocket'
import debounce from 'lodash.debounce'
import { mapGetters } from 'vuex';

export default {
  components : {
      TimeItem,
      Customers,
      TwTextarea,
      CustomButton
  },
  middleware: 'auth',
  data: function() {
    return {
      issueQuery: '',
      customerQuery: '',
      interruptionMode: false,
      interruptionMessage: '',
      interruptionComment: '',
      date: new Date(),
      pickerOptions: {
          disabledDate(time) {
              return time.getTime() > Date.now();
          },
          shortcuts: [{
              text: 'Today',
              onClick(picker) {
                  picker.$emit('pick', new Date());
              }
          }, {
              text: 'Yesterday',
              onClick(picker) {
                  const date = new Date();
                  date.setTime(date.getTime() - 3600 * 1000 * 24);
                  picker.$emit('pick', date);
              }
          }, {
              text: 'A week ago',
              onClick(picker) {
                  const date = new Date();
                  date.setTime(date.getTime() - 3600 * 1000 * 24 * 7);
                  picker.$emit('pick', date);
              }
          }]
      }
    }
  },
  computed: {
    ...mapGetters('time', [
        'durationFormatted'
    ]),
    ...{
        totalDuration : function() {
            return this.$store.getters['timeline/totalDuration'];
        },
        issuesList : function() {
            const issueQuery = this.issueQuery.toLowerCase() 

            return this.$store.state.issue.list.filter(issue => {
                if (!issue.project) {
                  return false
                }

                // Get the projects
                // Remove first project entry (Company-/User-name)
               
                let projects = issue.project.split(' / ')
                projects.shift()

                if (projects.find(project => project.toLowerCase().includes(issueQuery))) {
                    return true
                }

                return issue.title.toLowerCase().includes(issueQuery)
            });
        },
        activeItem() {
            return this.$store.state.timeline.active
        },
        timelineList() {
            return this.$store.state.timeline.list
        },
        timelineListWithoutActive() {
            return this.timelineList.filter(item => {
                return !item.is_active
            })
        },
        activeDurationFormatted() {
            if(!this.$store.state.timeline.active) {
                return '-'
            }
            return this.durationFormatted(this.$store.state.timeline.active.updated_at, true)
        }
    }
  },

  methods: {
    sendSocketSyncRequest() {
      this.$socket.sendObj({'userId': this.$auth.user.id});
    },
    fetchSocket(data) {
      if (data.data == this.$auth.user.id) {
        // reset before loading timeline
        this.$store.commit('timeline/reset');
        this.timeline();
      }
    },
    issues() {
      this.$axios.get('/issues').then(response => {
        this.$store.commit('issue/fill', response.data);
      })
    },

    async timeline() {
      return new Promise(resolve => {
        this.$store.commit('timeline/activate', null)
        const date = `${this.date.getDate()}-${this.date.getMonth() + 1}-${this.date.getFullYear()}`
        this.$axios.get('/timeline?date=' + date).then(response => {
          this.$store.commit('timeline/fill', response.data);
          response.data.forEach(value => {
              if (value.is_active) {
                this.$store.commit('timeline/activate', value);

                // see if its an interruption
                if (value.is_interruption && !value.costunit_id) {
                  this.interruptionMode = true;
                  this.interruptionMessage = value.message;
                  this.interruptionComment = value.comment;
                }
              }
          });

          resolve(true);
        })
      });
    },

    selectCostUnitForTime : function(costunit) {
      this.$axios.put('/time/' + this.$store.state.timeline.active.id, {'costunit_id' : costunit.id}).then(data => {
        this.timeline().then(response => {
          this.interruptionMode = false;  
        })
      });
    },

    async interruption() {
      if (this.$store.state.timeline.active) {
        await this.stopTimer(this.$store.state.timeline.active);
      }

      this.interruptionMode = true;

      this.$axios.post('/time', {
        is_interruption: 1,
        is_active: 1,
      }).then(response => {
        this.timeline();
      });
    },

    saveInerruptionMessage(message) {
        this.$axios.put('/time/' + this.$store.state.timeline.active.id, { message }).then(data => {
          //this.sendSocketSyncRequest();
        });
    },

    saveInterruptionComment(comment) {
        this.$axios.put('/time/' + this.$store.state.timeline.active.id, { comment }).then(data => {
          //this.sendSocketSyncRequest();
        });
    },

    async stopInterruption(costunit) {
        await this.restartTime(this.$store.state.timeline.active)
        this.selectCostUnitForTime(costunit);
        this.sendSocketSyncRequest();
    },
    
    async startIssueTimer(issue) {
      if (this.activeItem && this.activeItem.issue_id == issue.id) {
        // do nothing is its already active
        return;
      }

      if (this.$store.state.timeline.active) {
        await this.stopTimer(this.$store.state.timeline.active);
      }

      this.$axios.post('/time', {
        issue_id: issue.id,
        is_active: 1,
      }).then(response => {
        this.timeline();
        this.sendSocketSyncRequest();
      });
    },

    async startCostUnitTimer(costUnit) {
      if (this.activeItem && this.activeItem.costunit_id == costUnit.id) {
        // do nothing is its already active
        return;
      }

      if (this.$store.state.timeline.active) {
        await this.stopTimer(this.$store.state.timeline.active);
      }

      this.$axios.post('/time', {
        costunit_id: costUnit.id,
        is_active: 1,
      }).then(response => {
        this.sendSocketSyncRequest();
        this.timeline();
      });
    },

    async restartTime(time) {
      if (this.$store.state.timeline.active) {
        await this.stopTimer(this.$store.state.timeline.active);
      }

      this.$axios.put('/time/' + time.id, {'is_active': 1}).then(response => {
          this.sendSocketSyncRequest();
          this.timeline();
      });
    },

    stopTimer(active) {
        return new Promise(resolve => {
          var lastSec = active.updated_at;
          var now = Math.round((new Date()).getTime() / 1000);
          var duration = now - lastSec;

          this.$axios.put('/time/' + active.id, {'duration': duration + active.duration, 'is_active' : 0}).then(data => {
              resolve(true);
              this.sendSocketSyncRequest();
          });
        });
    },

    prevDay() {
        this.date = new Date(this.date.setDate(this.date.getDate() - 1))
    },

    nextDay() {
      this.date = new Date(this.date.setDate(this.date.getDate() + 1))
    },

    openGitlabLink(item) {
        window.open(item.gitlab_url, '_blank')
    }
  },
  watch: {
      date(newValue, oldValue) {
          this.timeline()
      },
      interruptionMessage: debounce(function(newVal) {
          this.saveInerruptionMessage(newVal)
      }, 500),
      interruptionComment: debounce(function(newVal) {
          this.saveInterruptionComment(newVal)
      }, 500),
  },
  created: function() {
      this.issues();
      this.timeline();
      this.$store.dispatch('customer/load');
      this.$store.dispatch('time/start');
  },
  mounted: function() {
      this.$socket.onmessage = this.fetchSocket;
  },
  beforeDestroy() {
      this.$store.dispatch('time/stop')
  }
}
</script>

<style>
</style>
